﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class FloatEqualsExpression : Expression
    {
        public FloatEqualsExpression() : base(OpCode.FloatEquals)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            PushResult(
                interpreterService.FloatStack,
                interpreterService.BooleanStack,
                2,
                values => values[1] == values[0]);
        }
    }
}
