﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class FloatMultiplyExpression : Expression
    {
        public FloatMultiplyExpression() : base(OpCode.FloatMultiply)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            PushResult(interpreterService.FloatStack, 2, values => values[1] * values[0]);
        }
    }
}
