﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class IntegerEqualsExpression : Expression
    {
        public IntegerEqualsExpression() : base(OpCode.IntegerEquals)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            PushResult(
                interpreterService.IntegerStack,
                interpreterService.BooleanStack,
                2,
                values => values[1] == values[0]);
        }
    }
}
