﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class IntegerGreaterThanExpression : Expression
    {
        public IntegerGreaterThanExpression() : base(OpCode.IntegerGreaterThan)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            PushResult(
                interpreterService.IntegerStack,
                interpreterService.BooleanStack,
                2,
                values => values[1] > values[0]);
        }
    }
}
