﻿//using System;
//using System.Collections.Generic;
//using HeuristicLab.Algorithms.PushGP.Data;
//using HeuristicLab.Algorithms.PushGP.Stack;

//namespace HeuristicLab.Algorithms.PushGP.InstructionSets
//{
//    public static class CommonInstructionSet
//    {
//        public static void Push<T>(IStack<T> stack, object[] arguments)
//        {
//            if (arguments.Length != 1)
//            {
//                throw new InvalidOperationException("Push method requires exactly one argument!");
//            }

//            var arg = (T)arguments[0];
//            stack.Push(arg);
//        }

//        public static T Pop<T>(IStack<T> stack)
//        {
//            return stack.Pop();
//        }

//        public static T[] Pop<T>(IStack<T> stack, int count)
//        {
//            return stack.Pop(count);
//        }

//        public static void Swap<T>(IStack<T> stack)
//        {
//            // not enough arguments on stack
//            if (stack.Count == 0)
//                return;

//            var values = stack.Pop(2);
//            stack.Push(values[1], values[0]);
//        }

//        public static void Duplicate<T>(IStack<T> stack)
//        {
//            // not enough arguments on stack
//            if (stack.Count == 0)
//                return;

//            var value = stack.ElementAt(0);
//            stack.Push(value);
//        }

//        public static void PushResult<T>(IStack<T> stack, int count, Func<T[], T> templateFunc)
//        {
//            PushResult(stack, stack, count, templateFunc);
//        }

//        public static void PushResult<T, R>(IStack<T> sourceStack, IStack<R> targetStack, int count, Func<T[], R> templateFunc)
//        {
//            // not enough arguments on stack
//            if (sourceStack.Count < count)
//                return;

//            var values = sourceStack.Pop(count);
//            var result = templateFunc(values);

//            targetStack.Push(result);
//        }

//        public static void Define<T>(IStack<T> stack, IStack<string> nameStack, IDictionary<string, Expression> customExpressions, OpCode pushOpCode)
//        {
//            // not enough arguments on stack
//            if (nameStack.Count == 0 ||
//                stack.Count == 0)
//                return;

//            var name = nameStack.Pop();
//            var expression = new Expression(pushOpCode, new object[] { stack.Top });

//            if (customExpressions.ContainsKey(name))
//            {
//                customExpressions[name] = expression;
//            }
//            else
//            {
//                customExpressions.Add(name, expression);
//            }
//        }
//    }
//}
