﻿//using HeuristicLab.Algorithms.PushGP.Data;
//using HeuristicLab.Algorithms.PushGP.Stack;

//namespace HeuristicLab.Algorithms.PushGP.InstructionSets
//{
//    public static class ExecInstructionSet
//    {
//        public static void Push(IInterpreterService interpreterService, object[] arguments)
//        {
//            CommonInstructionSet.Push(interpreterService.ExecStack, arguments);
//        }

//        public static void Pop(IInterpreterService interpreterService, object[] arguments)
//        {
//            CommonInstructionSet.Pop(interpreterService.ExecStack);
//        }

//        public static void Expand(IInterpreterService interpreterService, object[] arguments)
//        {
//            foreach (var arg in arguments)
//            {
//                var expression = arg as Expression;

//                interpreterService.ExecStack.Add(expression);
//            }
//        }

//        public static void Define(IInterpreterService interpreterService, object[] arguments)
//        {
//            CommonInstructionSet.Define(
//                interpreterService.ExecStack,
//                interpreterService.NameStack,
//                interpreterService.CustomExpressions,
//                OpCode.ExecPush);

//            interpreterService.ExecStack.Pop();
//        }

//        public static void Duplicate(IInterpreterService interpreterService, object[] arguments)
//        {
//            CommonInstructionSet.Duplicate(interpreterService.ExecStack);
//        }

//        public static void If(IInterpreterService interpreterService, object[] arguments)
//        {
//            // not enough arguments on stack
//            if (interpreterService.BooleanStack.Count == 0 ||
//                interpreterService.ExecStack.Count < 2)
//                return;

//            var condition = interpreterService.BooleanStack.Pop();
//            var expressionTrue = interpreterService.ExecStack.Pop();
//            var expressionFalse = interpreterService.ExecStack.Pop();

//            interpreterService.ExecStack.Push(condition
//                ? expressionTrue
//                : expressionFalse);
//        }

//        public static void Y(IInterpreterService interpreterService, object[] arguments)
//        {
//            // not enough arguments on stack
//            if (interpreterService.ExecStack.Count == 0)
//                return;

//            var expandExpression = new Expression(OpCode.ExecExpand, new[]
//            {
//                interpreterService.ExecStack.Top,
//                new Expression(OpCode.ExecY)
//            });

//            interpreterService.ExecStack.Insert(1, expandExpression);
//        }

//        public static void DoRange(IInterpreterService interpreterService, object[] arguments)
//        {
//            // not enough arguments on stack
//            if (interpreterService.IntegerStack.Count < 2 ||
//                interpreterService.ExecStack.Count == 0)
//                return;

//            var destinationIndex = interpreterService.IntegerStack.Pop();
//            var currentIndex = interpreterService.IntegerStack.Pop();
//            var loopBody = interpreterService.ExecStack.Pop();

//            if (destinationIndex == currentIndex)
//            {
//                interpreterService.IntegerStack.Push(currentIndex);
//                interpreterService.ExecStack.Push(loopBody);
//            }
//            else
//            {
//                var nextIndex = destinationIndex < currentIndex
//                    ? currentIndex - 1
//                    : currentIndex + 1;

//                interpreterService.IntegerStack.Push(currentIndex);
//                interpreterService.IntegerStack.Push(nextIndex);
//                interpreterService.IntegerStack.Push(destinationIndex);

//                var expression = new Expression(OpCode.ExecDoXRange);
//                interpreterService.ExecStack.Push(loopBody);
//                interpreterService.ExecStack.Push(loopBody);
//                interpreterService.ExecStack.Push(expression);
//            }
//        }
//    }
//}
