﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class ExecPopExpression : Expression
    {
        public ExecPopExpression() : base(OpCode.ExecPop)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            interpreterService.ExecStack.Pop();
        }
    }
}
