﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class IntegerAddExpression : Expression
    {
        public IntegerAddExpression() : base(OpCode.IntegerAdd)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            PushResult(interpreterService.IntegerStack, 2, values => values[1] + values[0]);
        }
    }
}
