﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class NamePopExpression : Expression
    {
        public NamePopExpression() : base(OpCode.NamePop)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            interpreterService.NameStack.Pop();
        }
    }
}
